unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, HotSpotImage, StdCtrls, HotSpotEditorComp;

type
  TForm2 = class(TForm)
    HotSpotImage1: THotSpotImage;
    Button2: TButton;
    lblQuestion: TLabel;
    Label2: TLabel;
    lblScore: TLabel;
    Label1: TLabel;
    Label3: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button2Click(Sender: TObject);
    procedure HotSpotImage1HotSpotClick(Sender: TObject; HotSpot: THotSpot);
    procedure Label3Click(Sender: TObject);
  private
    { Private declarations }
    Countries: array[0..34] of string;
    AnswersCorrect: integer;
    CountryID: integer;
    CountryIDs: TList;           // random sequence
  public
    { Public declarations }
    procedure NextCountry;
  end;

var
  Form2: TForm2;

implementation

uses
  ShellAPI;

{$R *.dfm}

procedure TForm2.Button2Click(Sender: TObject);
var
  i: integer;
begin
  CountryIDs.Clear;
  for i := 0 to 33 do
    CountryIDS.Add(pointer(i));

  for i := 0 to HotSpotImage1.HotSpots.Count - 1 do
  begin
    HotSpotImage1.HotSpots[i].Down := false;
    HotSpotImage1.HotSpots[i].ClickColor := clLime;
    HotSpotImage1.HotSpots[i].SelectedColor := clAqua;
    HotSpotImage1.HotSpots[i].HoverColor := clYellow;
  end;


  AnswersCorrect := 0;
  NextCountry;
end;

procedure TForm2.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  CountryIDs.Free;
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
  Randomize;
  Countries[0] := 'Norway';
  Countries[1] := 'Sweden';
  Countries[2] := 'Finland';
  Countries[3] := 'Estonia';
  Countries[4] := 'Latvia';
  Countries[5] := 'Lithaunia';
  Countries[6] := 'Belarus';
  Countries[7] := 'Ukraine';
  Countries[8] := 'Moldava';
  Countries[9] := 'Romania';
  Countries[10] := 'Bulgaria';
  Countries[11] := 'Greece';
  Countries[12] := 'Albania';
  Countries[13] := 'Serbia';
  Countries[14] := 'Bosnia';
  Countries[15] := 'Croatia';
  Countries[16] := 'Italia';
  Countries[17] := 'Swiss';
  Countries[18] := 'Austria';
  Countries[19] := 'Germany';
  Countries[20] := 'Netherlands';
  Countries[21] := 'Luxemburg';
  Countries[22] := 'Belgium';
  Countries[23] := 'France';
  Countries[24] := 'Spain';
  Countries[25] := 'United Kingdom';
  Countries[26] := 'Ireland';
  Countries[27] := 'Iceland';
  Countries[28] := 'Macedonia';
  Countries[29] := 'Slovakia';
  Countries[30] := 'Czech Republic';
  Countries[31] := 'Poland';
  Countries[32] := 'Portugal';
  Countries[33] := 'Slovenia';

  CountryIDs := TList.Create;
  CountryID := -1;
end;

procedure TForm2.HotSpotImage1HotSpotClick(Sender: TObject; HotSpot: THotSpot);
begin
  if CountryID = -1 then  // do nothing
    Exit;

  if HotSpot.ID = CountryID then
  begin
    Showmessage('Correct country selected!');
    HotSpot.ClickColor := clLime;
    HotSpot.Selected := false;
    HotSpot.Down := true;
    inc(AnswersCorrect);
  end
  else
  begin
    HotSpot.SelectedColor := clPurple;
    ShowMessage('Sorry, you missed. This country is '+ HotSpot.Name);
  end;

  NextCountry;
end;

procedure TForm2.Label3Click(Sender: TObject);
begin
  ShellExecute(0,'open','http://www.tmssoftware.com/',nil,nil,SW_NORMAL);
end;

procedure TForm2.NextCountry;
var
  country: string;
  rnd: integer;
begin
  if CountryIDS.count = 0 then
    ShowMessage('Game over.'#13#10'Your score is '+inttostr(AnswersCorrect)+'/34')
  else
  begin
    rnd := random(CountryIDs.Count);
    countryID := integer(CountryIDs.Items[rnd]);
    CountryIDS.Delete(rnd);
    country := Countries[countryID];
    lblQuestion.Caption := 'Click on country : ' + country;
    lblScore.Caption := inttostr(AnswersCorrect)+'/34';
  end;
end;

end.
